$:.unshift File::dirname(__FILE__)
require 'mailserver_agent/ygg'

module MailServerAgent
  def self.root
    Pathname.new(File::dirname(File::dirname(__FILE__)))
  end

  class BulkSync
    attr_accessor :domains, :boxes, :relext
    def initialize
      load_data
    end

    def load_data
      self.domains ||= Ygg::SimpleService::Email::Domain.view(:provisioning).all
    end

    def sync
      load_data
      sync_domains
    rescue 
      ex = $!
      if defined?(Raven)
        Raven.capture_exception(ex)
      end
      raise ex
    end
      

    protected

    def sync_domains
      keys = domains.map do | dom |
        dom.store!
        dom.cabinet_key
      end
      Ygg::SimpleService::Email::Domain.get_stored.each do | dom |
        next if keys.include?(dom.cabinet_key)
        dom.delete_stored!
      end
      Ygg::SimpleService::Email::Domain.provision!
      #Models::Email::Domain.transaction do
      #  ygg_pks = []
      #  domains.each do | domain | 
      #    ygg_pks << domain.uuid if domain.create_or_update_db_domain!
      #  end

      #  db_pks = Models::Email::Domain.all.map(&:uuid)
      #  old = db_pks - ygg_pks

      #  if old.any?
      #    old = Models::Email::Domain.where(uuid: old)
      #    doms = old.map(&:domain).map{|d| "@#{d}"}
      #    Models::Amavis::User.where(email: doms).map(&:destroy)
      #    old.map(&:destroy!)
      #  end 
      #end
    end
  end
end